!c***warning***warning***warning***warning***warning***warning***
!c
!c this version of the hydrocarbon potential is currently
!c (8/3/95) unpublished. there may still be some small changes
!c forthcoming, particularly with respect to interstitial
!c hydrogen in diamond. for updates, e-mail d. brenner at
!c dwb@ripley.mte.ncsu.edu.
!c
!c input coordinate file coord.d is written over; remember to
!c keep a backup copy!!!!!
!c
!c***warning***warning***warning***warning***warning***warning***

      subroutine caguts
        use variables
        use constants
        use bre_commons
        use bookkeep_param
!c
!c calculate two-body forces and neighbor list for hydrocarbons
!c
      implicit double precision(a-h,o-z)
!c
!      include 'common_files.inc'
!c
      dimension rpp(nlmax,3),rr(3),ri(3)
      integer :: atom_number
      logical, save :: initialize = .true.
!c


      if (initialize) then
         print *,'Initialize of the Brenner potential..'
         call bresetin
         call bresetpp
         call breparam
!         if (TRIM(potential_arg)=='Sn') then
!            do i=1,n
!               if (atom_number(asp(i))/=50) then
!                  print *,i,'-th atom is not Sn'; stop
!               endif
!               ktype(i)=kt(14)
!               noa(ktype(i))=noa(ktype(i))+1
!            enddo
!         else
         do i=1,n
            ktype(i)=kt(atom_number(asp(i)))
            noa(ktype(i))=noa(ktype(i))+1
         enddo
!         endif
         if (noa(3)/=0) stop 'Brenner-Si contains serious bug.'
         if (noa(4)/=0) stop 'Brenner-Ge contains serious bug.'
!         if (mtersoff==3) then
!            if (noa(3)/=n) then
!               print *,'Tersoff I/II is for Si only'
!               stop
!            endif
!         endif
!         if (mtersoff==4) then
!            if (noa(3)/=n) then
!               print *,'Tersoff Sn is for Sn only'
!               stop
!            endif
!         endif
         initialize = .false.
      endif

      np=n
      cube(1)=hmat(1,1)/ang
      cube(2)=hmat(2,2)/ang
      cube(3)=hmat(3,3)/ang
     do i=1,n
         r0(i,1)=rx(i)/ang
         r0(i,2)=ry(i)/ang
         r0(i,3)=rz(i)/ang
!         ktype(i)=kt(atom_number(asp(i)))
!         noa(ktype(i))=noa(ktype(i))+1
      enddo

      do i=1,np
           eatom(i) = 0.0d0
           do j=1,3
              rnp(i,j) = 0.0d0
           enddo
      enddo
!c
!      if(lchk.eq.1) then
      if ((mod(step,nbk)==0).or.(step==step_start+1)) then
         print *,'Bookkeep for the Brenner potential..'
!c
!c set up neighbor list
!c
           k=0
           do 302 i=1,np
                nabors(i)=k+1
                do 299 l=1,3
                     ri(l)=r0(i,l)
299             continue
                ki=ktype(i)
!c
!c cuts out all but c,h,si, and ge
!c
                if(ki.ge.5) go to 302
!c
                do 301 j=1,np
!c
                     if(i.eq.j) go to 301
!c
                     kj=ktype(j)
!c
!c cuts out all but c,h,si, and ge
!c
                     if(kj.ge.5) go to 301
                     rlis=rlist(ki,kj)
                     rlis = (frc/ang)**2
!c
                     rsq=0.0d0
                     do 298 l=1,3
                          rr(l)=ri(l)-r0(j,l)
                          if (((l==1).and.(pbcx)).or.((l==2).and.(pbcy)).or.((l==3).and.pbcz)) then
                          rr(l)=rr(l) - cube(l)*anint(rr(l)/cube(l))
                          endif
                          rsq=rsq+rr(l)*rr(l)
                          if(rsq.gt.rlis) go to 301
298                  continue
!c
405                  continue
                     k=k+1
                     list(k)=j
                     ivct2b(k)=i
                     jvct2b(k)=j
!c
301             continue
302        continue
!c
           nabors(np+1)=k+1
           kend=k
           if(kend.gt.nlmax) then
                 write(*,*) 'kend exceeds nlmax'
                 write(*,*) 'kend,nlmax = ',kend,nlmax
                 write(*,*) 'increase nlmax and recompile' 
!                 include 'close.inc' 
                 stop 
           endif
!           write(*,*) 'kend= ',kend
      endif
!c
      do 320 k=1,kend
!c
           i=ivct2b(k)
           j=jvct2b(k)
           ki=ktype(i)
           kj=ktype(j)
!c
           lcheck(k)=0
           rsq=0.0d0
           do l=1,3
                rr(l)=r0(i,l)-r0(j,l)
                if (((l==1).and.(pbcx)).or.((l==2).and.(pbcy)).or.((l==3).and.pbcz)) then
                rr(l)=rr(l) - cube(l)*anint(rr(l)/cube(l))
                endif
                rsq=rsq+rr(l)*rr(l)
                cor(k,l)=rr(l)
           enddo
!c
           if(rsq.gt.rmax(ki,kj)) goto 320
           if((kj.le.2).and.(ki.le.2)) lcheck(k)=1
           if((kj.ge.3).and.(ki.ge.3)) lcheck(k)=2
           rc=sqrt(rsq)
           rt = rc/ddtab(ki,kj)
           it = min(int(rt) + 1,ntab-1)

           rcor(k)=rc
!c
           bww(k)=tabfc(ki,kj,it) &
                +(tabfc(ki,kj,it+1)-tabfc(ki,kj,it))*(rt-it+1)
           dww(k)=tabdfc(ki,kj,it) &
                +(tabdfc(ki,kj,it+1)-tabdfc(ki,kj,it))*(rt-it+1)
!c
          exx1(k) = atable(ki,kj,it) &
               +(atable(ki,kj,it+1)-atable(ki,kj,it))*(rt-it+1)
          dexx1(k) = datable(ki,kj,it) + &
               (datable(ki,kj,it+1)-datable(ki,kj,it))*(rt - it +1)
!c
          if(i.ge.j) go to 320
!c
          vv = rtable(ki,kj,it) &
               +(rtable(ki,kj,it+1)-rtable(ki,kj,it))*(rt-it+1)
          rp = drtable(ki,kj,it) &
               +(drtable(ki,kj,it+1)-drtable(ki,kj,it))*(rt-it+1)
          tote = tote + vv

          eatom(i) = eatom(i) + vv/2.0d0
          eatom(j) = eatom(j) + vv/2.0d0

          do 318 l=1,3
               rpp(k,l)=rp*rr(l)
318       continue
320   continue

!c
      do 321 k=1,kend
           if(lcheck(k).eq.0) go to 321
           i=ivct2b(k)
           j=jvct2b(k)
           if(i.ge.j) go to 321
            do 322 l=1,3
                rnp(i,l)=rnp(i,l) + rpp(k,l)
                rnp(j,l)=rnp(j,l) - rpp(k,l)
322        continue
321   continue
!c
!c
! 1:C 2:H 3:Si 4:Ge
      if(noa(1)+noa(2).ne.0) call pibond
      if(noa(3)+noa(4).ne.0) then
         stop 'Brenner-Si/Ge contains serious bug!'
!         if (mtersoff == 3) then
!            call sili_germ
!         else
!            call sili_germ2
!         endif
      endif

!c
      enpot=0.0d0
      do i=1,np
         fx(i)=rnp(i,1)*ev/ang
         fy(i)=rnp(i,2)*ev/ang
         fz(i)=rnp(i,3)*ev/ang
         enpoteach(i)=eatom(i)*ev
         enpot=enpot+enpoteach(i)
      enddo
      return
!c
    end subroutine caguts
!c

