!
! Wrapper for calling energy & force calculation subroutine
!
      subroutine potential
      use constants, only: potential_func, asp, potential_arg
      if (potential_func=='EMT_ST1') then
         call emt_St_JCP1990
      else if (TRIM(potential_func)=='EMT_HM1') then
         call emt_HM_JP1989
      else if (TRIM(potential_func)=='EMT_JSN') then
         call emt_JSN_SS1996
      else if (TRIM(potential_func)=='EAM_MIS') then
         call eam_Mishin
      else if (TRIM(potential_func)=='EAM_FS1') then
         call eam_FS
      else if ((TRIM(potential_func)=='Tersoff').and.(potential_arg(1:1)/='M')) then
         call tersoff
      else if ((TRIM(potential_func)=='Tersoff').and.(potential_arg(1:1)=='M')) then
         call tersoff_multi
      else if ((TRIM(potential_func)=='TersoffNM').and.(potential_arg(1:1)/='M')) then
         call tersoff_nomat
      else if ((TRIM(potential_func)=='TersoffNM').and.(potential_arg(1:1)=='M')) then
         call tersoff_multi_nomat
      else if (TRIM(potential_func)=='TersoffBelko') then
         call tersoff_belko_nomat
      else if (TRIM(potential_func)=='Morse') then
         call morse
!      else if (TRIM(potential_func)=='Terpotn') then
!         call tersoff_terpotn
      else if (TRIM(potential_func)=='StilWeb') then
         call sw
      else if ((TRIM(potential_func)=='MEAM').and.(potential_arg(1:3)=='SiC')) then
         call meam_HuangSiC
      else if ((TRIM(potential_func)=='MEAM').and.(potential_arg(1:2)=='Sn')) then
         call meam_RaveloSn
      else if ((TRIM(potential_func)=='EAM').and.(TRIM(potential_arg)=='NiAl')) then
         call eam_nial
      else if ((TRIM(potential_func)=='EAM').and.(TRIM(potential_arg)=='TiAl')) then
         call eam_tial
      else if ((TRIM(potential_func)=='EAM').and.(TRIM(potential_arg)=='ZopeAl')) then
         call eam_tial
      else if ((TRIM(potential_func)=='EAM').and.(TRIM(potential_arg)=='Mishin')) then
         call eam_Mishin
      else if ((TRIM(potential_func)=='GEAM').and.(TRIM(potential_arg)=='PRB')) then
         call eam_geam_PRB
      else if ((TRIM(potential_func)=='GEAM').and.(TRIM(potential_arg)=='AM')) then
         call eam_geam_AM
      else if ((TRIM(potential_func)=='EAM').and.(TRIM(potential_arg)=='GEAM')) then
         call eam_geam_AM
      else if ((TRIM(potential_func)=='Shellmodel').and.(TRIM(potential_arg)=='PTO')) then
         call shellmodel_PTO
      else if (TRIM(potential_func)=='Brenner') then
!         if ((TRIM(potential_arg)=='TerI').or.(TRIM(potential_arg)=='TerII')) then
!            call caguts_ter12 ! Tersoff I or II (for Si)
!         else
         call caguts ! Brenner for H/C, Tersoff III for Si/Ge, or Tersoff I/II for Si
!         endif
      else
         print *,'No potential for ',potential_func,potential_arg
         stop
      endif
      end
